Attribute VB_Name = "Fonction"
Option Explicit


'Public Const Pi = 3.14159265358979
Public PI As Double
Public RADTODEG As Double
Public DEGTORAD As Double

Public Const INFINITY As Double = 9E+99

'--------------
' 3 couleurs
'-------------
Public Type CouleurRVB
  Rouge As Long
  Vert As Long
  Bleu As Long
End Type

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type

'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3D
    G As Integer
    X As Double
    Y As Double
    Z As Double
End Type

'---------------------------------------------------------------------------
' Triangle en 3D
'---------------------------------------------------------------------------
Public Type Triangle3
   S(2) As Point3       'Points sommets (3) du triangle
End Type

Public Declare Function GetInputState Lib "user32" () As Long


'Calcul centre du triangle
Function CentreTriangle(Tri As Triangle3) As Point3
Dim Poi As Point3
    
    Poi = PointMillieu(Tri.S(0), Tri.S(1))
    CentreTriangle = PointMillieu(Poi, Tri.S(2))

End Function




Function Atan2(ByVal X, ByVal Y)
    'On Error Resume Next
    '0 a PI
    If Y = 0 Then
        If X = 0 Then
            Atan2 = 0
        ElseIf X > 0 Then
            Atan2 = 0 'PI / 2
        Else
            Atan2 = PI '-PI / 2
        End If
    ElseIf X = 0 Then
        If Y > 0 Then
            Atan2 = PI / 2
        Else
            Atan2 = -PI / 2
        End If
    ElseIf X > 0 Then
        Atan2 = Atn(Y / X)
    Else
        Atan2 = (PI - Atn(Abs(Y) / Abs(X))) * Sgn(Y)
    End If
End Function
Function mfncParseString(strIn As String, intOffset As Integer, strDelimiter As String) As String
       '*** DESCRIPTION:Parses the passed string, returning the value indicated
       '     '***by the offset specified, eg: the string "Hello, World ","
       '     '***offset 2 = "World".
       '     '*** RETURNS:See description.
       '     '*** NOTE: The offset starts at 1 and the delimiter is the Character
       '     '***which separates the elements of the string.
       '     'Trap any bad calls

              If Len(strIn) = 0 Or intOffset = 0 Then
                     mfncParseString = ""
                     Exit Function
              End If

       '     'Declare local variables
       Dim intStartPos As Integer
       ReDim intDelimPos(10) As Integer
       Dim intStrLen As Integer
       Dim intNoOfDelims As Integer
       Dim intCount As Integer
       Dim strQuotationMarks As String
       Dim intInsideQuotationMarks As Integer
       strQuotationMarks = Chr(34) & Chr(147) & Chr(148)
       intInsideQuotationMarks = False

              For intCount = 1 To Len(strIn)
                     'If character is a double-quote then toggle the In Quotation
                     '      flag

                            If InStr(strQuotationMarks, Mid$(strIn, intCount, 1)) <> 0 Then
                                   intInsideQuotationMarks = (Not intInsideQuotationMarks)
                            End If


                            If (Not intInsideQuotationMarks) And (Mid$(strIn, intCount, 1) = strDelimiter) Then
                                   intNoOfDelims = intNoOfDelims + 1
                                   '     'If array filled then enlarge it, keeping existing contents

                                          If (intNoOfDelims Mod 10) = 0 Then
                                                 ReDim Preserve intDelimPos(intNoOfDelims + 10)
                                          End If

                                   intDelimPos(intNoOfDelims) = intCount
                            End If

              Next intCount

       '     'Handle request for value not present (over-run)

              If intOffset > (intNoOfDelims + 1) Then
                     mfncParseString = ""
                     Exit Function
              End If

       '     'Handle boundaries of string

              If intOffset = 1 Then
                     intStartPos = 1
              End If

       '     'Requesting last value - handle null

              If intOffset = (intNoOfDelims + 1) Then

                            If Right$(strIn, 1) = strDelimiter Then
                                   intStartPos = -1
                                   intStrLen = -1
                                   mfncParseString = ""
                                   Exit Function
                            Else
                                   intStrLen = Len(strIn) - intDelimPos(intOffset - 1)
                            End If

              End If

       'Set start and length variables if not handled by boundary c
       '     heck above

              If intStartPos = 0 Then
                     intStartPos = intDelimPos(intOffset - 1) + 1
              End If


              If intStrLen = 0 Then
                     intStrLen = intDelimPos(intOffset) - intStartPos
              End If

       '     'Set the return string
       mfncParseString = Mid$(strIn, intStartPos, intStrLen)
End Function

'****************************************************************
' Name: A 'strtok' function for VB
' Description:I wrote four functions to tokenize strings. He
'     re they are...
'The functions work like this TokLeftLeft finds the leftmost token and
'then returns the left part of the string (empty if not there). You
'can figure out the rest. Note that if the token is more than 1 character
'then the function will always return "".
'****************************************************************
Public Function TokLeftLeft(Source As String, token As String) As String

       Dim I As Integer
       TokLeftLeft = Source

              For I = 1 To Len(Source)

                            If Mid(Source, I, 1) = token Then
                                   TokLeftLeft = Left(Source, I - 1)
                                   Exit Function
                            End If

              Next I

End Function
Public Function TokLeftRight(Source As String, token As String) As String

       Dim I As Integer
       TokLeftRight = Source

              For I = 1 To Len(Source)

                            If Mid(Source, I, 1) = token Then
                                   TokLeftRight = Right(Source, Len(Source) - I)
                                   Exit Function
                            End If

              Next I

End Function
Public Function TokRightLeft(Source As String, token As String) As String

       Dim I As Integer
       TokRightLeft = ""

              For I = Len(Source) To 1 Step -1

                            If Mid(Source, I, 1) = token Then
                                   TokRightLeft = Left(Source, I - 1)
                                   Exit Function
                            End If

              Next I

End Function
Public Function TokRightRight(Source As String, token As String) As String

       Dim I As Integer
       TokRightRight = ""

              For I = Len(Source) To 1 Step -1

                            If Mid(Source, I, 1) = token Then
                                   TokRightRight = Right(Source, Len(Source) - I)
                                   Exit Function
                            End If

              Next I

End Function




Function Longueur(P1 As Point3) As Double
  Longueur = Sqr((P1.X ^ 2) + (P1.Y ^ 2) + (P1.Z ^ 2))
End Function

Function Distance(P1 As Point3, P2 As Point3) As Double
    Distance = Sqr((P2.X - P1.X) ^ 2 + (P2.Y - P1.Y) ^ 2 + (P2.Z - P1.Z) ^ 2)
End Function
'Addition de vecteur
Function VecAdd(P1 As Point3, P2 As Point3, Optional f As Double = 1) As Point3
 VecAdd.X = P1.X + f * P2.X
 VecAdd.Y = P1.Y + f * P2.Y
 VecAdd.Z = P1.Z + f * P2.Z
End Function

'Produit Scalaire
Function Dot(p As Point3, q As Point3) As Double
    Dot = p.X * q.X + p.Y * q.Y + p.Z * q.Z
End Function
Function SubVect(P1 As Point3, P2 As Point3, f As Double) As Point3
 SubVect.X = P1.X - P2.X * f
 SubVect.Y = P1.Y - P2.Y * f
 SubVect.Z = P1.Z - P2.Z * f
End Function

'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function


' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function
'rcupration du vecteur normal de 3 points
Function NormVec(P1 As Point3, P2 As Point3, P3 As Point3) As Point3
 NormVec = VecteurUnitaire(VecProd(VecSub(P1, P2), VecSub(P3, P2)))
End Function

' transforme un vecteur en vecteur unitaire
Function VecteurUnitaire(P1 As Point3) As Point3
Dim Norm As Double
Norm = Sqr((P1.X) ^ 2 + (P1.Y) ^ 2 + (P1.Z) ^ 2)
If Norm = 0 Then
    Exit Function
End If
    
    VecteurUnitaire.X = P1.X / Norm
    VecteurUnitaire.Y = P1.Y / Norm
    VecteurUnitaire.Z = P1.Z / Norm
End Function
' Coordones du point Milieu
Function PointMillieu(P1 As Point3, P2 As Point3) As Point3
 PointMillieu.X = 0.5 * (P1.X + P2.X)
 PointMillieu.Y = 0.5 * (P1.Y + P2.Y)
 PointMillieu.Z = 0.5 * (P1.Z + P2.Z)
End Function
'****************************************************************
' Name: Round
'
' Inputs:DP is the decimal place to round to (0 to 14) e.g
' Round (3.56376, 3) will give the result 3.564
' Round (3.56376, 1) will give the result 3.6
' Round (3.56376, 0) will give the result 4
' Round (3.56376, 2) will give the result 3.56
' Round (1.4999, 3) will give the result 1.5
' Round (1.4899, 2) will give the result 1.49
' Returns:None
' Assumes:None
' Side Effects:None
'
'****************************************************************
Function Round(x1 As Double, DP As Integer) As Double
    Round = Int((x1 * 10 ^ DP) + 0.5) / 10 ^ DP
End Function

Function ACOS(ang)
    Select Case ang
        Case 1
            ACOS = 0 '0
        Case -1
            ACOS = 4 * Atn(1) 'PI
        Case Else
            ACOS = 2 * Atn(1) - Atn(ang / Sqr(1 - ang * ang))
    End Select
End Function

Function ASIN(ang)
    Select Case ang
        Case 1
            ASIN = 2 * Atn(1)
        Case -1
            ASIN = -2 * Atn(1)
        Case Else
            ASIN = Atn(ang / Sqr(1 - ang * ang))
    End Select
End Function

'Angle entre 2 Vecteurs forms concourant en 0
Function AngleVect(Po1 As Point3, Po2 As Point3, Normal As Point3) As Double
Dim VEC1 As Point3
Dim VEC2 As Point3
Dim Po3 As Point3
Dim Signe As Double

VEC1 = Po1
VEC2 = Po2
If Longueur(VEC1) = 0 Or Longueur(VEC2) = 0 Then
    AngleVect = 0
Else
    If Distance(Po1, Po2) = 0 Then
        AngleVect = 0
    Else

        Po3 = VecProd(VEC1, VEC2)
        Signe = Sgn(Dot(Po3, Normal))
        
        'Debug.Print " Dot/Normal         | " & Signe
        
        'Debug.Print " Po3         | " & Format(Po3.x, "#,###0.0000") & " | " & Format(Po3.y, "#,###0.0000") & " | " & Format(Po3.Z, "#,###0.0000") & " | "
        AngleVect = Signe * RADTODEG * (ACOS((VEC1.X * VEC2.X + VEC1.Y * VEC2.Y + VEC1.Z * VEC2.Z) / (Longueur(VEC1) * Longueur(VEC2))))
    End If
End If
                    
End Function
'Angle entre 2 Vecteurs forms de 3 point ( attention ne gre pas de valeur + ou -)
Function Angle3Pt(Po1 As Point3, Po2 As Point3, Po3 As Point3) As Double
Dim VEC1 As Point3
Dim VEC2 As Point3

VEC1 = VecSub(Po1, Po2)
VEC2 = VecSub(Po2, Po3)
If Distance(Po3, Po2) = 0 Or Distance(Po1, Po2) = 0 Then
    Angle3Pt = 0
Else
    If Distance(Po1, Po3) = 0 Then
        Angle3Pt = 180
    Else
        Angle3Pt = RADTODEG * (ACOS((VEC1.X * VEC2.X + VEC1.Y * VEC2.Y + VEC1.Z * VEC2.Z) / (Distance(Po3, Po2) * Distance(Po1, Po2))))
    End If
End If
                    
End Function
'Angle entre 2 Vecteurs forms de 3 point ( attention ne gre pas de valeur + ou -)
Function Angle3PtPlan(Po1 As Point3D, Po2 As Point3D, Po3 As Point3D) As Double
Dim VEC1 As Point3
Dim VEC2 As Point3

Dim Pot1 As Point3
Dim Pot2 As Point3
Dim Pot3 As Point3

Pot1.X = Po1.X
Pot1.Y = Po1.Y
Pot2.X = Po2.X
Pot2.Y = Po2.Y
Pot3.X = Po3.X
Pot3.Y = Po3.Y

On Error GoTo fin

VEC1 = VecSub(Pot1, Pot2)
VEC2 = VecSub(Pot2, Pot3)


If Distance(Pot3, Pot2) = 0 Or Distance(Pot1, Pot2) = 0 Then
    Angle3PtPlan = 0
Else
    If Distance(Pot1, Pot3) = 0 Then
        Angle3PtPlan = 180
    Else
        Angle3PtPlan = RADTODEG * (ACOS((VEC1.X * VEC2.X + VEC1.Y * VEC2.Y + VEC1.Z * VEC2.Z) / (Distance(Pot3, Pot2) * Distance(Pot1, Pot2))))
    End If
End If
        '            Debug.Print
  Exit Function
  
fin:
 ' Debug.Print "erreur"
  Angle3PtPlan = 180
End Function
Public Function AngleTrigo(X As Single, Y As Single, Cx As Single, Cy As Single) As Single
Dim Xd As Single
Dim Yd As Single
Dim a As Single
Dim b As Single

Dim Larg As Single

Dim A1 As Single
Dim A2 As Single
Dim A3 As Single
Dim A4 As Single

Dim Poss1 As Single
Dim Poss2 As Single
Dim Poss3 As Single
Dim Poss4 As Single

Xd = X - Cx
Yd = Y - Cy
Larg = Sqr(Xd ^ 2 + Yd ^ 2)
a = Xd / Larg
b = Yd / Larg

Poss1 = MesurePrincipale(InvCos(a))
Poss2 = MesurePrincipale(2 * PI - Poss1)
Poss3 = MesurePrincipale(InvSin(b))
Poss4 = MesurePrincipale(PI - Poss3)

A1 = Abs(Poss1 - Poss3)
A2 = Abs(Poss1 - Poss4)
A3 = Abs(Poss2 - Poss3)
A4 = Abs(Poss2 - Poss4)

If A1 <= A2 And A1 <= A3 And A1 <= A4 Then AngleTrigo = (Poss1 + Poss3) / 2
If A2 <= A1 And A2 <= A3 And A2 <= A4 Then AngleTrigo = (Poss1 + Poss4) / 2
If A3 <= A2 And A3 <= A1 And A3 <= A4 Then AngleTrigo = (Poss2 + Poss3) / 2
If A4 <= A2 And A4 <= A3 And A4 <= A1 Then AngleTrigo = (Poss2 + Poss4) / 2
End Function

Public Function MesurePrincipale(Angle As Single) As Single
While Angle > PI
    Angle = Angle - 2 * PI
Wend
While Angle < -PI
    Angle = Angle + 2 * PI
Wend
MesurePrincipale = Angle
End Function

Public Function InvCos(X As Single) As Single
Dim ang As Single
Dim Aprox1 As Single
Dim Aprox2 As Single
Dim temp As Single

For ang = 0 To 2 * PI Step PI / 100
    Aprox1 = Cos(ang - PI / 200)
    Aprox2 = Cos(ang + PI / 200)
    If Aprox1 > Aprox2 Then
     temp = Aprox1
     Aprox1 = Aprox2
     Aprox2 = temp
    End If
    If X >= Aprox1 And X <= Aprox2 Then InvCos = ang: Exit For
Next
End Function

Public Function InvSin(X As Single) As Single
Dim ang As Single
Dim Aprox1 As Single
Dim Aprox2 As Single
Dim temp As Single

For ang = 0 To 2 * PI Step PI / 100
    Aprox1 = Sin(ang - PI / 200)
    Aprox2 = Sin(ang + PI / 200)
    If Aprox1 > Aprox2 Then
     temp = Aprox1
     Aprox1 = Aprox2
     Aprox2 = temp
    End If
    If X >= Aprox1 And X <= Aprox2 Then
     InvSin = ang: Exit For
    End If
Next
End Function
Function Unix2Dos(ByVal fic_in As String) As Integer
Dim errorcode As Integer
Dim Donneslues As String
Dim Pos_Char10 As Integer
Dim Pos_Char13 As Integer

Dim line_tempo As String

' Initialisation
errorcode = 0

On Error GoTo fin

If Len(fic_in) = 0 Then
errorcode = 2
GoTo fin
End If



Open fic_in For Binary As #1 ' Ouvre le fichier en lecture
errorcode = 4
     Donneslues = Input(255, #1) ' Lit 255 char.
     Pos_Char13 = InStr(1, Donneslues, Chr(13))
     Pos_Char10 = InStr(1, Donneslues, Chr(10))

    If Not (Pos_Char10 - Pos_Char13) = 1 Then
         Close #1    ' Ferme le fichier.
         If Len(Dir(fic_in + "~!")) Then Kill (fic_in + "~!")
         
         'Name fic_in As "Bak_" + fic_in
         Open fic_in For Binary As #1   ' Ouvre le fichier en lecture
            Open fic_in + "~!" For Binary As #2    ' Ouvre le fichier en lecture
                Do While Not EOF(1) ' Cherche la fin du fichier.
                    Donneslues = Input(255, #1) ' Lit une ligne de donnes.
                        'Do While InStr(1, Donneslues, Chr(10))  ' Cherche la fin du fichier.
                            line_tempo = Replace(Donneslues, Chr(10), vbNewLine)
                            'TokLeftLeft(Donneslues, Chr(10)) + vbnewline
                            Put #2, , line_tempo
                            'Donneslues = TokLeftRight(Donneslues, Chr(10))
                        'Loop ' fin boucle traitement fichier
                   Loop ' fin boucle traitement fichier
            Close #2    ' Ferme le fichier.
         Close #1    ' Ferme le fichier.
         If Len(Dir(fic_in + ".bak")) Then Kill (fic_in + ".bak")
         Name fic_in As fic_in + ".bak"
         If GetInputState Then DoEvents
         Name fic_in + "~!" As fic_in
         'Call Kill(fic_in + "~!")
         errorcode = 1
    Else
            Close #1    ' Ferme le fichier.
    End If

fin:
Unix2Dos = errorcode
End Function

'****************************************************************
' Name: GetFilename
' Description:This function takes a fully qualified filename
'     /path and parses it into individual parts and returns one of
'      the the parts (drive, path, filename, or extension) based o
'     n its parameters. Useful to use in building strings and mani
'     pulating filenames. Complete error handling. Supports long f
'     ilenames.
' By: Chris Cubley
'
' Inputs:GetFilename(FName As String, ReturnType As Integer)
'FName is a string containing the filename and path.
'ReturnType tells the function what to return.
'0 -- Returns the drive letter
'1 -- Returns the directory path
'2 -- Returns the filename (without the extension)
'3 -- Returns the extension
' Returns:The function returns a string containing the portion of the filename/path you specified in ReturnType. If the string did not contain the requested part, it returns a zero-length string.
' Assumes:Put it in a bas file and call the function, that's all there is to it. Used like Any other function.
' Side Effects:If ReturnType is not a valid value (i.e. not 0-3), then the function returns no value and raises and error with error code 1.
'
'Code provided by Planet Source Code(tm) 'as is', without
'     warranties as to performance, fitness, merchantability,
'     and any other warranty (whether expressed or implied).
'****************************************************************
Public Function FormatFileName(ByVal TempPath As String, ReturnType As Integer)

       Dim DriveLetter As String
       Dim DirPath As String
       Dim FName As String
       Dim Extension As String
       Dim PathLength As Integer
       Dim ThisLength As Integer
       Dim Offset As Integer
       Dim FileNameFound As Boolean

              If ReturnType <> 0 And ReturnType <> 1 And ReturnType <> 2 And ReturnType <> 3 Then
                     Err.Raise 1
                     Exit Function
              End If

       DriveLetter = ""
       DirPath = ""
       FName = ""
       Extension = ""

              If Mid(TempPath, 2, 1) = ":" Then ' Find the drive letter.
                     DriveLetter = Left(TempPath, 2)
                     TempPath = Mid(TempPath, 3)
              End If

       PathLength = Len(TempPath)

              For Offset = PathLength To 1 Step -1 ' Find the next delimiter.
                     Select Case Mid(TempPath, Offset, 1)
                      Case ".": ' This indicates either an extension or a . or a ..
                      ThisLength = Len(TempPath) - Offset
                      If ThisLength >= 1 Then ' Extension
                      Extension = Mid(TempPath, Offset, ThisLength + 1)
                      End If
                      TempPath = Left(TempPath, Offset - 1)
                      Case "\": ' This indicates a path delimiter.
                      ThisLength = Len(TempPath) - Offset
                      If ThisLength >= 1 Then ' Filename
                      FName = Mid(TempPath, Offset + 1, ThisLength)
                      TempPath = Left(TempPath, Offset)
                      FileNameFound = True
                      Exit For
                      End If
                      Case Else
              End Select

Next Offset


If FileNameFound = False Then
       FName = TempPath
Else
       DirPath = TempPath
End If


If ReturnType = 0 Then
       FormatFileName = DriveLetter
ElseIf ReturnType = 1 Then
       FormatFileName = DirPath
ElseIf ReturnType = 2 Then
       FormatFileName = FName
ElseIf ReturnType = 3 Then
       FormatFileName = Extension
End If

End Function


