Attribute VB_Name = "OpenGL"
Option Explicit

Global ZoomFenetre As Boolean

Dim HGLRC As Long

' Variables pour la manipulation 3D opengl
'**********************************************************
' LISTE
'**********************************************************
Public Const MAILLAGE_STL = 1
Public Const NUAGE_POINTS = 2
Public Const LA_GRILLE = 3


Global PosX As GLfloat   'translation pour visu 3D
Global PosY As GLfloat

Global SVGposX As GLfloat
Global SVGposY As GLfloat

Global Zoom As Single

Global ObjectAlpha As Single 'Tranparence
Global Xm As Single, Ym As Single, Zm As Single ' Rotation pour visu 3D

Global PMax As Point3 ' Point Maxi et Mini
Global PMin As Point3
Global PMillieu As Point3

Global Large As Long


Global Facteur_diff As Integer
Global Facteur_zoom As Double


'Arret de simulation si appui sur ESC
Global Stop_Exec As Boolean

'public const INREAL float
Public ExpectedError& ' As GLenum


Public Const GLU_ERROR = GLU_TESS_ERROR

Type Point4f
    pts(0 To 3) As Single
End Type

Dim theNurbs& ' As GLUnurbsObj
'Public Const S_NUMPOINTS = 9   ' Nombre de points
Global S_NUMPOINTS As Integer
Global S_ORDER As Integer
Global S_NUMKNOTS As Integer
'Public Const S_ORDER = 9       ' Degre de la nurbs+1
'Public Const S_NUMKNOTS = (S_NUMPOINTS + S_ORDER)
'Public Const T_NUMPOINTS = 3
'Public Const T_ORDER = 3
'Public Const T_NUMKNOTS = (T_NUMPOINTS + T_ORDER)
'Public Const SQRT_TWO = 1.4142135623731

'Dim sknots!(0 To S_NUMKNOTS - 1)
Dim sknots!()
'Dim glutnots!(0 To T_NUMKNOTS - 1)
'Dim ctlpoints(0 To (S_NUMPOINTS * T_NUMPOINTS - 1)) As Point4f
'Dim ctlpoints(0 To (S_NUMPOINTS - 1)) As Point4f
Dim ctlpoints() As Point4f
Dim Validpoints(0 To 32) As Point4f


' mise a jour param manip en fonction de la taille
Sub MiseAjourParamVisu()
Dim dist As Double

dist = Distance(PMin, PMax)
If dist = 0 Then dist = 1
Debug.Print dist
Debug.Print "Calcul " & ((dist * Sqr(2) * 0.5) + 20) * 0.01

Large = ((dist * Sqr(2) * 0.5) + 20) * 0.01

If Large = 0 Then Large = 1

' pourquoi *.001 et aprs *100 -> pour avoir un arrondi
Large = 100 * Large


Facteur_diff = Large / 50 '20

Zoom = 2 / Large
Facteur_zoom = Zoom * 0.02


 PosX = 0
 PosY = 0
 
 SVGposX = PosX
 SVGposY = PosY
End Sub

'Reglage du format de pixel
Sub SetupPixelFormat(ByVal hdc As Long)
    Dim PFD As PIXELFORMATDESCRIPTOR
    Dim PixelFormat As Integer
    PFD.nSize = Len(PFD)
    PFD.nVersion = 1
    PFD.dwFlags = PFD_SUPPORT_OPENGL Or PFD_DRAW_TO_WINDOW Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
    PFD.iPixelType = PFD_TYPE_RGBA
    PFD.cColorBits = 16
    PFD.cDepthBits = 16
    PFD.iLayerType = PFD_MAIN_PLANE
    PixelFormat = ChoosePixelFormat(hdc, PFD)
    If PixelFormat = 0 Then MsgBox ("format de pixels inconnu")
    SetPixelFormat hdc, PixelFormat, PFD
End Sub

'--------------------------------
' Definition de l'eclairage
'--------------------------------
Sub Lampe()
    Dim aflLightAmbient1(4) As GLfloat
    Dim aflLightDiffuse1(4) As GLfloat
    Dim aflLightSpecular1(4) As GLfloat
    Dim aflLightPosition1(4) As GLfloat
    
    Dim aflLightAmbient2(4) As GLfloat
    Dim aflLightDiffuse2(4) As GLfloat
    Dim aflLightSpecular2(4) As GLfloat
    Dim aflLightPosition2(4) As GLfloat
    
    '    Dim aflLightAmbient3(4) As GLfloat
    '    Dim aflLightDiffuse3(4) As GLfloat
    '    Dim aflLightSpecular3(4) As GLfloat
    '    Dim aflLightPosition3(4) As GLfloat
    
    
    '========
    glEnable (GL_LIGHTING)
    glEnable (GL_LIGHT0)
    If FrmBase.Lampe2 Then
        glEnable (GL_LIGHT1)
    Else
        glDisable (GL_LIGHT1)
    End If
    
    Rem glEnable (GL_LIGHT2)
    
    
    ' Ambient light settings
    aflLightAmbient1(0) = Val(FrmBase.LightAmbiant1(0))
    aflLightAmbient1(1) = Val(FrmBase.LightAmbiant1(1))
    aflLightAmbient1(2) = Val(FrmBase.LightAmbiant1(2))
    'aflLightAmbient1(3) = 1
    
    ' Diffuse light settings
    aflLightDiffuse1(0) = Val(FrmBase.LightDiffuse1(0))
    aflLightDiffuse1(1) = Val(FrmBase.LightDiffuse1(1))
    aflLightDiffuse1(2) = Val(FrmBase.LightDiffuse1(2))
    aflLightDiffuse1(3) = 1
    ' Light position settings
    
    aflLightPosition1(0) = Val(FrmBase.LightPosition1(0))
    aflLightPosition1(1) = Val(FrmBase.LightPosition1(1))
    aflLightPosition1(2) = Val(FrmBase.LightPosition1(2))
    aflLightPosition1(3) = 1
    
    ' Light position Specular
    aflLightSpecular1(0) = Val(FrmBase.LightSpecular1(0))
    aflLightSpecular1(1) = Val(FrmBase.LightSpecular1(1))
    aflLightSpecular1(2) = Val(FrmBase.LightSpecular1(2))
    aflLightSpecular1(3) = 1
    
    '========================================
    ' Ambient light settings
    aflLightAmbient2(0) = Val(FrmBase.LightAmbiant2(0))
    aflLightAmbient2(1) = Val(FrmBase.LightAmbiant2(1))
    aflLightAmbient2(2) = Val(FrmBase.LightAmbiant2(2))
    aflLightAmbient2(3) = 1
    
    ' Diffuse light settings
    aflLightDiffuse2(0) = Val(FrmBase.LightDiffuse2(0))
    aflLightDiffuse2(1) = Val(FrmBase.LightDiffuse2(1))
    aflLightDiffuse2(2) = Val(FrmBase.LightDiffuse2(2))
    aflLightDiffuse2(3) = 1
    ' Light position settings
    
    aflLightPosition2(0) = Val(FrmBase.LightPosition2(0))
    aflLightPosition2(1) = Val(FrmBase.LightPosition2(1))
    aflLightPosition2(2) = Val(FrmBase.LightPosition2(2))
    aflLightPosition2(3) = 1
    
    ' Light position Specular
    aflLightSpecular2(0) = Val(FrmBase.LightSpecular2(0))
    aflLightSpecular2(1) = Val(FrmBase.LightSpecular2(1))
    aflLightSpecular2(2) = Val(FrmBase.LightSpecular2(2))
    aflLightSpecular2(3) = 1
    
    glLightfv GL_LIGHT0, GL_AMBIENT, aflLightAmbient1(0)
    glLightfv GL_LIGHT0, GL_DIFFUSE, aflLightDiffuse1(0)
    glLightfv GL_LIGHT0, GL_SPECULAR, aflLightSpecular1(0)
    glLightfv GL_LIGHT0, GL_POSITION, aflLightPosition1(0)
    
    glLightfv GL_LIGHT1, GL_AMBIENT, aflLightAmbient2(0)
    glLightfv GL_LIGHT1, GL_DIFFUSE, aflLightDiffuse2(0)
    glLightfv GL_LIGHT1, GL_SPECULAR, aflLightSpecular2(0)
    glLightfv GL_LIGHT1, GL_POSITION, aflLightPosition2(0)
    
    'glLightfv GL_LIGHT2, GL_AMBIENT, aflLightAmbient3(0)
    'glLightfv GL_LIGHT2, GL_DIFFUSE, aflLightDiffuse3(0)
    'glLightfv GL_LIGHT2, GL_SPECULAR, aflLightSpecular3(0)
    
    ' glLightfv GL_LIGHT2, GL_POSITION, aflLightPosition3(0)
    
End Sub
' initialisation OpenGL
Sub LoadGL(p As PictureBox)
    
    SetupPixelFormat p.hdc
    HGLRC = wglCreateContext(p.hdc)
    wglMakeCurrent p.hdc, HGLRC
    
    ' ????
    glEnable glcColorMaterial 'Allow material parameters track the current color
    glColorMaterial faceFront, cmmAmbientAndDiffuse 'Enable color tracking
    glClearDepth 1 'Set the clear value for the depth buffer
    
    
    '' Tres important pour transparance
    glEnable glcBlend 'enable alpha blending
    glBlendFunc sfSrcAlpha, dfOneMinusSrcAlpha 'set alpha blending options
    'glEnable glcDepthTest   'Enable depth comparisons
    glEnable glcColorMaterial

    ' Smooth shading
    glShadeModel smSmooth
    'glShadeModel smFlat
    
    ' Set the clear colour gris
    glClearColor 0.5, 0.5, 0.5, 0 '
    ' Set the clear depth
    glClearDepth 1#
    
    ' Enable Z-buffer
    glEnable glcDepthTest
    
    ' Set test type
     glDepthFunc cfLEqual
     
     'important
     ' Best perspective correction
     glHint htPerspectiveCorrectionHint, hmNicest
    
    'Meilleur Ombrage
    'Sinon les couleurs sont trop vive trop de contraste
     glEnable glcNormalize
    
    ' Init des traits cachs
    glEnable glcPolygonOffsetFill
    glPolygonOffset 2, 1
    'glPolygonMode faceFrontAndBack, pgmFILL

    glMatrixMode mmProjection
    glLoadIdentity
    gluPerspective 10, p.ScaleWidth / p.ScaleHeight, 1, 1000
    
    glMatrixMode mmModelView
    glLoadIdentity
    
    

    
    theNurbs = gluNewNurbsRenderer
    gluNurbsCallback theNurbs, GLU_ERROR, AddressOf ErrorCallback
    gluNurbsProperty theNurbs, GLU_SAMPLING_TOLERANCE, 15
    gluNurbsProperty theNurbs, GLU_DISPLAY_MODE, GLU_OUTLINE_PATCH
    ExpectedError = GLU_INVALID_ENUM
    '
    'don't know what heis trying to set, it crashes VB
    'gluNurbsProperty theNurbs, &HFFFFFFFF, 15
    'gluNurbsProperty theNurbs, , 15
    'ExpectedError = GLU_NURBS_ERROR13
    'gluEndSurface theNurbs
    'ExpectedError = 0
    glColor3f 0.8, 0.8, 1
    glDisable glcLighting
    '
    'debug test of the tlb
    Dim f!
    gluGetNurbsProperty theNurbs, npSamplingTolerance, f
    
    
    ' definition des lumieres
    Call Lampe
    
    Call Crer_spline
    Call Affiche_Grille

    
    
End Sub

Sub modify_degree()
Dim K As Integer
Dim I As Integer

Debug.Print S_ORDER
S_NUMKNOTS = S_NUMPOINTS + S_ORDER
Debug.Print S_NUMKNOTS
ReDim sknots(0 To S_NUMKNOTS - 1)

For K = 0 To S_ORDER - 1
    sknots(K) = 0
Next K

For K = S_ORDER To S_NUMPOINTS - 1
    I = I + 1
    sknots(K) = I
Next K

For K = S_NUMPOINTS To (S_NUMPOINTS + S_ORDER) - 1
    sknots(K) = I + 1
Next K

    'sknots(0) = 0
    'sknots(1) = 0
    'sknots(2) = 0
    'sknots(3) = 0
    'sknots(4) = 0
    'sknots(5) = 0
    'sknots(6) = 0
    'sknots(7) = 0
    'sknots(8) = 0
    'sknots(9) = 1
    'sknots(10) = 1
    'sknots(11) = 1
    'sknots(12) = 1
    'sknots(13) = 1
    'sknots(14) = 1
    'sknots(15) = 1
    'sknots(16) = 1
    'sknots(17) = 1
'    sknots(18) = 1
    'sknots(19) = 1
    'sknots(20) = 1
    'sknots(21) = 1
    'sknots(22) = 1
    'sknots(23) = 1
    'sknots(24) = 1
    '

End Sub

Sub Crer_spline()


ReDim ctlpoints(S_NUMPOINTS - 1)
     Call modify_degree
     
' point de dfinition de la spline

FillPoint4f ctlpoints(0), 18.3787083305, -8.84683511808, 0, 1
FillPoint4f ctlpoints(1), 19.5749793369, -6.7786581136, 0, 1
FillPoint4f ctlpoints(2), 19.8425963912, -4.17329118497, 0, 1
FillPoint4f ctlpoints(3), 18.9026601853, -1.5185055101, 0, 1
FillPoint4f ctlpoints(4), 16.7729193868, 0.528866925985, 0, 1
FillPoint4f ctlpoints(5), 13.9362409451, 1.35396399408, 0, 1
FillPoint4f ctlpoints(6), 11.1663729301, 0.844848867327, 0, 1
FillPoint4f ctlpoints(7), 9.04150472583, -0.686324152521, 0, 1
FillPoint4f ctlpoints(8), 7.84535683561, -2.75457236159, 0, 1


' point de controle calcul sur le cercle
FillPoint4f Validpoints(0), 7.845, -2.755, 0, 1
FillPoint4f Validpoints(1), 8.169, -2.253, 0, 1
FillPoint4f Validpoints(2), 8.541, -1.786, 0, 1
FillPoint4f Validpoints(3), 8.956, -1.357, 0, 1
FillPoint4f Validpoints(4), 9.412, -0.971, 0, 1
FillPoint4f Validpoints(5), 9.903, -0.632, 0, 1
FillPoint4f Validpoints(6), 10.425, -0.342, 0, 1
FillPoint4f Validpoints(7), 10.973, -0.105, 0, 1
FillPoint4f Validpoints(8), 11.542, 0.077, 0, 1
FillPoint4f Validpoints(9), 12.126, 0.203, 0, 1
FillPoint4f Validpoints(10), 12.719, 0.271, 0, 1
FillPoint4f Validpoints(11), 13.316, 0.28, 0, 1
FillPoint4f Validpoints(12), 13.911, 0.231, 0, 1
FillPoint4f Validpoints(13), 14.498, 0.123, 0, 1
FillPoint4f Validpoints(14), 15.072, -0.041, 0, 1
FillPoint4f Validpoints(15), 15.627, -0.261, 0, 1
FillPoint4f Validpoints(16), 16.158, -0.534, 0, 1
FillPoint4f Validpoints(17), 16.66, -0.858, 0, 1
FillPoint4f Validpoints(18), 17.127, -1.229, 0, 1
FillPoint4f Validpoints(19), 17.556, -1.645, 0, 1
FillPoint4f Validpoints(20), 17.942, -2.101, 0, 1
FillPoint4f Validpoints(21), 18.281, -2.592, 0, 1
FillPoint4f Validpoints(22), 18.571, -3.114, 0, 1
FillPoint4f Validpoints(23), 18.808, -3.662, 0, 1
FillPoint4f Validpoints(24), 18.99, -4.231, 0, 1
FillPoint4f Validpoints(25), 19.116, -4.814, 0, 1
FillPoint4f Validpoints(26), 19.183, -5.407, 0, 1
FillPoint4f Validpoints(27), 19.193, -6.004, 0, 1
FillPoint4f Validpoints(28), 19.144, -6.599, 0, 1
FillPoint4f Validpoints(29), 19.036, -7.187, 0, 1
FillPoint4f Validpoints(30), 18.872, -7.761, 0, 1
FillPoint4f Validpoints(31), 18.652, -8.316, 0, 1
FillPoint4f Validpoints(32), 18.379, -8.847, 0, 1
'

End Sub

Public Sub FillPoint4f(p As Point4f, a!, b!, c!, d!)
p.pts(0) = a
p.pts(1) = b
p.pts(2) = c
p.pts(3) = d
End Sub

Public Sub ErrorCallback(which&) ' As GLenum)
    If which <> ExpectedError Then
        Debug.Print "Unexpected error occured " & which
        Debug.Print gluErrorString(which)
        Debug.Assert 0
    End If
End Sub

' affiche info dans la fenetre
Sub Info(T As String, Optional UneLigne As Boolean = False)
    
    With FrmBase
        If .MessageLOG.CurrentY >= .MessageLOG.ScaleHeight Or UneLigne Then
            .MessageLOG.Cls
            .MessageLOG.CurrentY = 0
        End If
        
        
        .MessageLOG.Print T
    End With
    If GetInputState Then DoEvents
End Sub

Sub RenduOpengl(Pict As PictureBox, GRILLE As Boolean) ', Render_mode As Integer, Point_mode As Integer, Rayon As Double)
Dim K As Integer
Dim obj As Long
'Dim Pt1 As Point3
'Dim MMatrix(1 To 16) As Double


On Error Resume Next

'---DEBUT :
    glClear GL_COLOR_BUFFER_BIT Or GL_DEPTH_BUFFER_BIT
    glMatrixMode mmModelView

'---PETITE INITALISATION :
     glViewport 0, 0, Pict.ScaleWidth, Pict.ScaleHeight
     
'---POINT DE VUE : Camera

        gluLookAt 20, 0, 0, 0, 0, 0, 0, 0, 20
        
        glRotatef Xm, 0, 1, 0  ' rotation en y
        glRotatef Ym, 1, 0, 0  ' rotation en x
        glRotatef Zm, 0, 0, 1  ' rotation en z
        glTranslatef PosY * Zoom, PosY * Zoom, PosX * Zoom

'----Zoom
        glScalef Zoom, Zoom, Zoom


'---GRILLE :
        
If GRILLE Then
    glCallList LA_GRILLE
End If

'---AFFICHAGE
glPushMatrix


    'glClear GL_COLOR_BUFFER_BIT
     '   gluBeginSurface theNurbs
     '   gluNurbsSurface theNurbs, S_NUMKNOTS, sknots(0), T_NUMKNOTS, glutnots(0), _
     '       4 * T_NUMPOINTS, 4, ctlpoints(0).pts(0), S_ORDER, _
     '       T_ORDER, GL_MAP2_VERTEX_4
     '   gluEndSurface theNurbs
     
'-----------------------------------------------------------------------------
'  Parameters
'-----------------------------------------------------------------------------
' nobj      Specifies the NURBS object (created with gluNewNurbsRenderer).
'
' nknots    Specifies the number of knots in knot.  nknots equals the number
'        of control points plus the order.
' knot      Specifies an array of nknots nondecreasing knot values.
'
' stride    Specifies the offset (as a number of single-precision floating-
'            point values) between successive curve control points.
'
' ctlarray  Specifies a pointer to an array of control points.  The
'           coordinates must agree with type, specified below.
'
'  order     Specifies the order of the NURBS curve.  order equals degree + 1,
'        hence a cubic curve has an order of 4.
'
'  type      Specifies the type of the curve.  If this curve is defined within
'        a gluBeginCurve/gluEndCurve pair, then the type can be any of the
'        valid one-dimensional evaluator types (such as GL_MAP1_VERTEX_3
'        or GL_MAP1_COLOR_4).  Between a gluBeginTrim/gluEndTrim pair, the
'        only valid types are GLU_MAP1_TRIM_2 and GLU_MAP1_TRIM_3.

     
        glColor4f 0, 0, 1, 1
        gluBeginCurve theNurbs
        gluNurbsCurve theNurbs, S_NUMKNOTS, sknots(0), 4, ctlpoints(0).pts(0), S_ORDER, GL_MAP1_VERTEX_4  ' GL_MAP1_VERTEX_3
        gluEndCurve theNurbs

        obj = gluNewQuadric 'create new quadric object
        For K = 0 To UBound(ctlpoints)
            Select Case K
            
            Case 0 'premier point en vert
                glColor4f 0, 1, 0, 1
            Case UBound(ctlpoints) ' dernier point en rouge
                glColor4f 1, 0, 0, 1
            Case Else ' point suivant en gris
                glColor4f 0.5, 0.5, 0.5, 1
            End Select
            
            glTranslatef ctlpoints(K).pts(0), ctlpoints(K).pts(1), ctlpoints(K).pts(2)
            
            gluSphere obj, 0.25, 16, 16
            glTranslatef -ctlpoints(K).pts(0), -ctlpoints(K).pts(1), -ctlpoints(K).pts(2)
        Next K
'GoTo fin
            glColor3d 1, 0, 0  'en rouge
            glBegin bmLineStrip
                For K = 0 To UBound(Validpoints)
                    glVertex3f Validpoints(K).pts(0), Validpoints(K).pts(1), Validpoints(K).pts(2)
                Next
            glEnd
fin:
glPopMatrix
SwapBuffers Pict.hdc

'Reinitialise la matrice
glLoadIdentity
End Sub



Sub Affiche_Grille()
Dim Z As Single
Dim T As Single
Dim obj As Long
Dim I As Integer
Dim PasGrille As Integer

    glNewList LA_GRILLE, GL_COMPILE_AND_EXECUTE
    glPushMatrix
    
    Z = Facteur_diff
    If Z = 0 Then Z = 1
    
    T = Large / Z
    'T = 50
    'Z = 20
    
    glTranslatef 0, 0, 0
    glBegin bmLines
    glColor3d 1, 1, 1
    glEnable GL_DEPTH_TEST
    'X
    For I = -T To T Step 10
        glVertex3f I * Z, -T * Z, 0
        glVertex3f I * Z, T * Z, 0
    Next
    'Y
    For I = -T To T Step 10
        glVertex3f -T * Z, I * Z, 0
        glVertex3f T * Z, I * Z, 0
    Next
    glEnd

  'GoTo fin
   obj = gluNewQuadric 'create new quadric object

    'gluQuadricNormals Obj, qnSmooth
   'glShadeModel smFlat
PasGrille = 2

    'AXE Z
    glColor4f 0.5, 0.5, 0.5, 1
    gluSphere obj, 0.8, 16, 16
    gluCylinder obj, 0.5, 0.5, PasGrille, 16, 1    'axe blanc
    glTranslatef 0, 0, PasGrille
    glColor4f 0.8, 0, 0, 1
    gluDisk obj, 0, 1, 16, 1                   'Cone rouge
    gluCylinder obj, 1, 0, PasGrille, 16, 1
    glTranslatef 0, 0, -PasGrille
    
    'AXE Y
    glRotatef -90, 1, 0, 0  ' rotation en X
    glColor4f 0.5, 0.5, 0.5, 1
    gluCylinder obj, 0.5, 0.5, PasGrille, 16, 1    'axe blanc
    glTranslatef 0, 0, PasGrille
    glColor4f 0, 0.8, 0, 1
    gluDisk obj, 0, 1, 16, 1                   'Cone vert
    gluCylinder obj, 1, 0, PasGrille, 16, 1
    glTranslatef 0, 0, -PasGrille
    glRotatef 90, 1, 0, 0  ' Annulation rotation en X
    
    'AXE X
    glRotatef 90, 0, 1, 0  ' rotation en Y
    glColor4f 0.5, 0.5, 0.5, 1
    gluCylinder obj, 0.5, 0.5, PasGrille, 16, 1    'axe blanc
    glTranslatef 0, 0, PasGrille
    glColor4f 0, 0, 0.8, 1
    gluDisk obj, 0, 1, 16, 1                   'Cone Bleu
    gluCylinder obj, 1, 0, PasGrille, 16, 1
    glTranslatef 0, 0, -PasGrille
    glRotatef -90, 0, 1, 0  ' Annulation rotation en X
fin:
    glPopMatrix
    glEndList

End Sub
'Reinit objet
Sub Reinit_MaxiMini()
    PMax.X = 1 '-INFINITY
    PMax.Y = 1 '-INFINITY
    PMax.Z = 1 '-INFINITY
    
    PMin.X = -1 'INFINITY
    PMin.Y = -1 'INFINITY
    PMin.Z = -1 'INFINITY
    
    PMillieu.X = 0
    PMillieu.Y = 0
    PMillieu.Z = 0
End Sub


